#include <fstream.h>  // TEST
#include <stdlib.h>


#include "d_Bitboard_gen.h"
#include "k_Util.h"
#include "d_Bitboard_const.h"
//-----------------------------------------------------------------------------------
/* ?    
 *   
 *
 *  ChessTerminator75
 *   18.1.2008
 *
 *  
 *        
*/
//---------------------------------------------------------------------------


//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_B
 ofstream Test_Bitboard;
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

/*

              &  0 0 1  
                  0 1 1  
                  -----
                  0 0 1 

            |  0 0 1
                  0 1 1
                  -----
                  0 1 1

    ^  0 0 1
               0 1 1
                  -----
                  0 1 0

*/
//	===================================================================
// 
void Bitboard_ini_t(T_Bitboard * bitboard,T_board_list_816 * board_list_816){
short int n_1=0;
int n=0;

//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_B
    Test_Bitboard.open ("_TEST_BITBOARD.txt",ios::app);
 //   Test_Bitboard.open ("_TEST_HASH.txt");
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

bitboard->all_white_piece =0;
bitboard->all_black_piece =0;

for(int i=0 ; i<8 ; i++){
  bitboard->white_piece[i]=0;
  bitboard->black_piece[i]=0;
}//for(int i=0 ; i<8 ; i++){

//  : 0 - ,1 -  2 -  3 -  4 -  5 -  6 -  

/*           
//  
  
 0 -  
 1 -  
 2 -  
 3 - 
 4 -  
 5 -  
 6 - 
*/
//
//

// 120       
while (n_1<120){
   if ((board_list_816->name_figure_816[n_1]!=0)&&(!(n_1 & 0x88))){
//  128    64  
    n = 8*(7-n_1/16)+(n_1%16);
    if (board_list_816->colour_figure_816[n_1]==1){
//----------------------------------------------------------------------------------
// 
      bitboard->all_white_piece =bitboard->all_white_piece | move_masks[n];

switch (board_list_816->name_figure_816[n_1]){
   case 0 :
   // 
   break;

   case 1 : //
	   //   
       bitboard->white_piece[1]=bitboard->white_piece[1] | move_masks[n];
	   //   
       bitboard->white_name_to_coord[n]=1;
   break;

   case 2 : //
	   //    (   4)
       bitboard->white_piece[4]=bitboard->white_piece[4] | move_masks[n];
	   //   
       bitboard->white_name_to_coord[n]=4;
   break;

   case 3 : //
       //    (   2)
       bitboard->white_piece[2]=bitboard->white_piece[2] | move_masks[n];
	   //   
       bitboard->white_name_to_coord[n]=2;
   break;

   case 4 : //
       //    (   3)
       bitboard->white_piece[3]=bitboard->white_piece[3] | move_masks[n];
	   //   
       bitboard->white_name_to_coord[n]=3;
   break;

   case 5 : //
       //    (   5)
       bitboard->white_piece[5]=bitboard->white_piece[5] | move_masks[n];
	   //   
       bitboard->white_name_to_coord[n]=5;
   break;

   case 6 : //
       //    (   6)
       bitboard->white_piece[6]=bitboard->white_piece[6] | move_masks[n];
	   //   
       bitboard->white_name_to_coord[n]=6;
   break;

   default:;//   
   
 }// switch (name){

//---------------------------------------------------------------------------------- 
 }else{
//----------------------------------------------------------------------------------
// 
      bitboard->all_black_piece =bitboard->all_black_piece | move_masks[n];

switch (board_list_816->name_figure_816[n_1]){
   case 0 :
   // 
   break;

   case 1 : //
	   //   
       bitboard->black_piece[1]=bitboard->black_piece[1] | move_masks[n];
	   //   
       bitboard->black_name_to_coord[n]=1;
   break;

   case 2 : //
	   //    (   4)
       bitboard->black_piece[4]=bitboard->black_piece[4] | move_masks[n];
	   //   
       bitboard->black_name_to_coord[n]=4;
   break;

   case 3 : //
       //    (   2)
       bitboard->black_piece[2]=bitboard->black_piece[2] | move_masks[n];
	   //   
       bitboard->black_name_to_coord[n]=2;
   break;

   case 4 : //
       //    (   3)
       bitboard->black_piece[3]=bitboard->black_piece[3] | move_masks[n];
	   //   
       bitboard->black_name_to_coord[n]=3;
   break;

   case 5 : //
       //    (   5)
       bitboard->black_piece[5]=bitboard->black_piece[5] | move_masks[n];
	   //   
       bitboard->black_name_to_coord[n]=5;
   break;

   case 6 : //
       //    (   6)
       bitboard->black_piece[6]=bitboard->black_piece[6] | move_masks[n];
	   //   
       bitboard->black_name_to_coord[n]=6;
   break;

   default:;//   
   
 }// switch (name){

//      bitboard->black_piece[1][1]=n;
//----------------------------------------------------------------------------------
     }//if (board_list_816.colour_figure_816[n_1]==1){

   }// if ((board_list_816.name_figure_816[n_1]!=0)&&(!(n_1 & 0x88))){
  n_1 = n_1 + 1;

}//while (n_1<129){


//        1 2  1 0
bitboard->colour_move = board_list_816->colour_move==1 ?  1 : 0;

//     1/0
bitboard->taking_passage_yes=board_list_816->taking_passage_yes;
//    (  ) 
bitboard->taking_passage_x=board_list_816->taking_passage_x;
//    (     ) 
bitboard->taking_passage_y=board_list_816->taking_passage_y;
//     
bitboard->castling_Q=board_list_816->castling_Q;
//     
bitboard->castling_K=board_list_816->castling_K;
//     
bitboard->castling_q=board_list_816->castling_q;
//     
bitboard->castling_k=board_list_816->castling_k;


#if TEST_B
   //Test_Bitboard << "  "<< "\n";
   //Test_Bitboard << "n_1 == "<< n_1 << "\n";
   //Test_Bitboard << "n == "<< n << "\n";
 
#endif 

//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_B
    Test_Bitboard.close();
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

}//void Bitboard_ini(T_Bitboard bitboard){
//	*******************************************************************

//	===================================================================
//
void Generator_move(T_Bitboard * bitboard,T_list_surplus_moves * list_surplus_moves,T_board_list_816 * board_list_816){
unsigned __int64 from_mask = 0;
unsigned __int64 captures_mask = 0;
unsigned __int64 move_mask = 0;
unsigned __int64 z_mask=0;
unsigned __int64 blocking_square_mask=0;
unsigned __int64 attack_mask=0;

unsigned __int64 move_mask_d = 0;
unsigned __int64 one_pawn_mask = 0;
unsigned __int64 move_conversion_mask = 0;
unsigned __int64 captures_conversion_mask = 0;

int blocking_coordinate = 0;
int from = 0;
int to = 0;

//   
short int p =0;
short int n=0;
short int n_1=0;
short int depth=0;

//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_B
    Test_Bitboard.open ("_TEST_BITBOARD.txt",ios::app);
 //   Test_Bitboard.open ("_TEST_HASH.txt");
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
//   .        
 depth = list_surplus_moves->current_depth;
 list_surplus_moves->start_list[depth] =depth*250;
 list_surplus_moves->end_list[depth]= depth*250;
 p = list_surplus_moves->end_list[depth];
if (bitboard->colour_move){
//    
//  ---------------------------------------------------------------------------------
{
//      
  from_mask = bitboard->white_piece[6];
 //    (   )
    from = first_one(from_mask);

//    
   captures_mask = (bitboard->all_black_piece & king_moves_masks[from]);

//    ( )
   move_mask = king_moves_masks[from] & (~(bitboard->all_white_piece | bitboard->all_black_piece));

//-------------------------------------------------------------------------------------
//      
  while (captures_mask !=0){
     to = first_one(captures_mask);
     captures_mask = captures_mask & (captures_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=6 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
   }//while (captures !=0){

//-------------------------------------------------------------------------------------

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask & (move_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=6 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
   }//while (move !=0){

//   
//          
   if (from == 4){
//    
	   if(bitboard->castling_Q){
//    1 2 3     
          if((~(bitboard->all_white_piece | bitboard->all_black_piece) & 14)==14){
          // move_mask = move_mask |  move_masks[2];
               list_surplus_moves->name_figure[p]=6 ;
	           list_surplus_moves->initial_position[p] = 116;
	           list_surplus_moves->final_position[p] = 114;
               list_surplus_moves->description_move[p] =3;
               p=p+1;
		  }//if(( (bitboard->all_white_piece | bitboard->all_black_piece) & 14)){ 
	   }//if(bitboard->castling_Q){
//        
	   if(bitboard->castling_K){
//    5 6     
          if((~(bitboard->all_white_piece | bitboard->all_black_piece) & 96)==96){
          // move_mask = move_mask |  move_masks[6];
              list_surplus_moves->name_figure[p]=6 ;
	          list_surplus_moves->initial_position[p] = 116;
	          list_surplus_moves->final_position[p] = 118;
              list_surplus_moves->description_move[p] =3;
              p=p+1;
		  }//if(( (bitboard->all_white_piece | bitboard->all_black_piece) & 96)){ 
	   }//if(bitboard->castling_K){
   
   }//if (from_mask == 4){

}
// ---------------------------------------------------------------------------------




//  ----------------------------------------------------------------------------------
{
  from_mask = bitboard->white_piece[5];
  while(from_mask != 0){
 //    
    from = first_one(from_mask);
//      b = b & (b-1)       
    from_mask = from_mask & (from_mask-1);

//     
//   ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_up_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = rook_up_masks[from] ^ rook_up_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_up_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_left_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = rook_left_masks[from] ^ rook_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//    ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_down_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = rook_down_masks[from] ^ rook_down_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_down_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_right_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = rook_right_masks[from] ^ rook_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_right_masks[from];
 }//if(blocking_square_mask !=0){ 
// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&


//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

//     
//   -  ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_up_right_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = bishop_up_right_masks[from] ^ bishop_up_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_up_right_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//   -  ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_up_left_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = bishop_up_left_masks[from] ^ bishop_up_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_up_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   -   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_down_left_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = bishop_down_left_masks[from] ^ bishop_down_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_down_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//     

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   -   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_down_right_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = bishop_down_right_masks[from] ^ bishop_down_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_down_right_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  }//while(from_mask != 0){

}
// ----------------------------------------------------------------------------------



//  ----------------------------------------------------------------------------------
{
  from_mask = bitboard->white_piece[4];
  while(from_mask != 0){
 //    
    from = first_one(from_mask);
//      b = b & (b-1)       
    from_mask = from_mask & (from_mask-1);

//     
//   ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_up_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = rook_up_masks[from] ^ rook_up_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_up_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_left_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = rook_left_masks[from] ^ rook_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//    ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_down_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = rook_down_masks[from] ^ rook_down_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_down_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_right_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = rook_right_masks[from] ^ rook_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_right_masks[from];
 }//if(blocking_square_mask !=0){ 
// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  }//while(from_mask != 0){

}
// ----------------------------------------------------------------------------------



//  ---------------------------------------------------------------------------------- 
{
  from_mask = bitboard->white_piece[3];
  while(from_mask != 0){
 //    
    from = first_one(from_mask);
//      b = b & (b-1)       
   from_mask = from_mask & (from_mask-1);
//     
//   -  ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_up_right_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = bishop_up_right_masks[from] ^ bishop_up_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_up_right_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//   -  ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_up_left_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = bishop_up_left_masks[from] ^ bishop_up_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_up_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   -   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_down_left_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = bishop_down_left_masks[from] ^ bishop_down_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_down_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//     

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   -   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_down_right_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = bishop_down_right_masks[from] ^ bishop_down_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_black_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_white_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_down_right_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


 }//while(from_mask != 0){

}
// ---------------------------------------------------------------------------------- 




//   ----------------------------------------------------------------------------------
{//               
//         
  from_mask = bitboard->white_piece[2];
  while(from_mask != 0){
 //    (   )
    from = first_one(from_mask);
//      b = b & (b-1)       
    from_mask = from_mask & (from_mask-1);


//    
   captures_mask = (bitboard->all_black_piece & knigt_moves_masks[from]);

//    ( )
   move_mask = knigt_moves_masks[from] & (~(bitboard->all_white_piece | bitboard->all_black_piece));


//      
  while (captures_mask !=0){
     to = first_one(captures_mask);
     captures_mask = captures_mask & (captures_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=3 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
   }//while (captures !=0){

//-------------------------------------------------------------------------------------

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask & (move_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=3 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
   }//while (move !=0){

 }// while(from_mask != 0){
}
//  ----------------------------------------------------------------------------------

//  ----------------------------------------------------------------------------------
{
  from_mask = bitboard->white_piece[1];
  while(from_mask != 0){
 //    (   )
    from = first_one(from_mask);
 //    
    one_pawn_mask = from_mask & move_masks[from];
//      b = b & (b-1)       
    from_mask = from_mask & (from_mask-1);

// 1         
  move_mask = (one_pawn_mask << 8) & (~(bitboard->all_white_piece | bitboard->all_black_piece));
// 2     2   
//        2 
  move_mask_d = one_pawn_mask & (255<<8);
//       
  move_mask_d = (move_mask_d <<8) & (~(bitboard->all_white_piece | bitboard->all_black_piece));
//    
  move_mask_d = (move_mask_d << 8) & (~(bitboard->all_white_piece | bitboard->all_black_piece));

//            
  move_mask = (move_mask | move_mask_d) ;


//   
  move_conversion_mask = move_mask & 18374686479671623680;

//   
  move_mask = move_mask & ~18374686479671623680;

// 3   
//  (    ..   1)   (    ..   h1)
 captures_mask = ((one_pawn_mask << 9) & ~72340172838076673) | ((one_pawn_mask << 7) & ~9259542123273814144);
 captures_mask = captures_mask &  bitboard->all_black_piece;

//   
captures_conversion_mask = captures_mask & 18374686479671623680;

//  
captures_mask = captures_mask & ~18374686479671623680;

//     
  while (captures_mask !=0){
    to = first_one(captures_mask);
    captures_mask = captures_mask & (captures_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=1 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
   }//while (captures !=0){

//    
  while (move_mask !=0){
    to = first_one(move_mask);
    move_mask = move_mask & (move_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=1 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     p=p+1;
   }//while (captures !=0){

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//      
  while (move_conversion_mask !=0){
    to = first_one(move_conversion_mask);
    move_conversion_mask = move_conversion_mask & (move_conversion_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

//   
//    4,   5,   6,   7,
      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =4;
      p=p+1;
      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =5;
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =6;
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =7;
      p=p+1;
   }//while (captures !=0){

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//        
  while (captures_conversion_mask !=0){
    to = first_one(captures_conversion_mask);
    captures_conversion_mask = captures_conversion_mask & (captures_conversion_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

//     
//      8,     9,
//      10,     11,
	  list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =8;
      list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =9;
      list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =10;
      list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =11;
      list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1];
       p=p+1;
   }//while (captures !=0){

// 4    
 if(bitboard->taking_passage_yes == 1){
//   
   to = 8*(7-bitboard->taking_passage_y)+(bitboard->taking_passage_x);
  if ( (((to - from) == 9)&&(from % 8!=7)) || (((to - from) == 7)&&(from % 8!=0) ) ){
//  64    128  
       n = 16 * (7 - from / 8)+(from % 8);
       n_1 = 16 * (7 - to / 8)+(to % 8);
	   list_surplus_moves->name_figure[p]=1 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
       list_surplus_moves->description_move[p] =2;
       list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1+16]; 
       p=p+1;
    }
  }//if(bitboard->taking_passage_yes == 1){
}//while(from_mask != 0){
// ----------------------------------------------------------------------------------
}

}else{
//    
//  ---------------------------------------------------------------------------------
{
//      
  from_mask = bitboard->black_piece[6];
 //    (   )
    from = first_one(from_mask);

//    
   captures_mask = (bitboard->all_white_piece & king_moves_masks[from]);

//    ( )
   move_mask = king_moves_masks[from] & (~(bitboard->all_white_piece | bitboard->all_black_piece));

//-------------------------------------------------------------------------------------

//      
  while (captures_mask !=0){
     to = first_one(captures_mask);
     captures_mask = captures_mask & (captures_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=6 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
   }//while (captures !=0){

//-------------------------------------------------------------------------------------

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask & (move_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=6 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
   }//while (move !=0){
////-------------------------------------------------------------------------------------
//Test_Bitboard << "\n";
//Test_Bitboard << "1008806316530991104"<< "\n";
//	for (int i=63; i>-1 ; i=i-8){
//       for (int j=i-7; j<i+1 ; j++){
//         z_mask= 1008806316530991104 & move_masks[j];
//
//         if (z_mask == 0){
//           Test_Bitboard << "-";
//         }else{
//           Test_Bitboard << "*";
//         }//if (z == 0){ 
//	   }//for ( j=i-7; i>j+1 ; j++){
//       Test_Bitboard << "\n";
//   }//for (int i=63; i>-1 ; i--){
////-------------------------------------------------------------------------------------
////-------------------------------------------------------------------------------------
//Test_Bitboard << "\n";
//Test_Bitboard << "6917529027641081856"<< "\n";
//	for (int i=63; i>-1 ; i=i-8){
//       for (int j=i-7; j<i+1 ; j++){
//         z_mask= 6917529027641081856 & move_masks[j];
//
//         if (z_mask == 0){
//           Test_Bitboard << "-";
//         }else{
//           Test_Bitboard << "*";
//         }//if (z == 0){ 
//	   }//for ( j=i-7; i>j+1 ; j++){
//       Test_Bitboard << "\n";
//   }//for (int i=63; i>-1 ; i--){
////-------------------------------------------------------------------------------------
//   
//          
   if (from == 60){
//    
	   if(bitboard->castling_q){
//    1 2 3     
          if((~(bitboard->all_white_piece | bitboard->all_black_piece) & 1008806316530991104)==1008806316530991104){
          // move_mask = move_mask |  move_masks[2];
               list_surplus_moves->name_figure[p]=6 ;
	           list_surplus_moves->initial_position[p] = 4;
	           list_surplus_moves->final_position[p] = 2;
               list_surplus_moves->description_move[p] =3;
               p=p+1;
		  }//if(( (bitboard->all_white_piece | bitboard->all_black_piece) & 14)){ 
	   }//if(bitboard->castling_Q){
//        
	   if(bitboard->castling_k){
//    5 6     
          if((~(bitboard->all_white_piece | bitboard->all_black_piece) & 6917529027641081856)==6917529027641081856){
          // move_mask = move_mask |  move_masks[6];
              list_surplus_moves->name_figure[p]=6 ;
	          list_surplus_moves->initial_position[p] = 4;
	          list_surplus_moves->final_position[p] = 6;
              list_surplus_moves->description_move[p] =3;
              p=p+1;
		  }//if(( (bitboard->all_white_piece | bitboard->all_black_piece) & 96)){ 
	   }//if(bitboard->castling_K){
   
   }//if (from_mask == 60){

}
// ---------------------------------------------------------------------------------




//  ----------------------------------------------------------------------------------
{
  from_mask = bitboard->black_piece[5];
  while(from_mask != 0){
 //    
    from = first_one(from_mask);
//      b = b & (b-1)       
    from_mask = from_mask & (from_mask-1);

//     
//   ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_up_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = rook_up_masks[from] ^ rook_up_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_up_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_left_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = rook_left_masks[from] ^ rook_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//    ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_down_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = rook_down_masks[from] ^ rook_down_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_down_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_right_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = rook_right_masks[from] ^ rook_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_right_masks[from];
 }//if(blocking_square_mask !=0){ 
// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&


//&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

//     
//   -  ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_up_right_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = bishop_up_right_masks[from] ^ bishop_up_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_up_right_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//   -  ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_up_left_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = bishop_up_left_masks[from] ^ bishop_up_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_up_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   -   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_down_left_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = bishop_down_left_masks[from] ^ bishop_down_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_down_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//     

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   -   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_down_right_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = bishop_down_right_masks[from] ^ bishop_down_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_down_right_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=5;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  }//while(from_mask != 0){

}
// ----------------------------------------------------------------------------------



//  ----------------------------------------------------------------------------------
{
  from_mask = bitboard->black_piece[4];
  while(from_mask != 0){
 //    
    from = first_one(from_mask);
//      b = b & (b-1)       
    from_mask = from_mask & (from_mask-1);

//     
//   ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_up_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = rook_up_masks[from] ^ rook_up_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_up_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_left_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = rook_left_masks[from] ^ rook_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//    ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_down_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = rook_down_masks[from] ^ rook_down_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_down_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & rook_right_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = rook_right_masks[from] ^ rook_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = rook_right_masks[from];
 }//if(blocking_square_mask !=0){ 
// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//      

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=2 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  }//while(from_mask != 0){

}
// ----------------------------------------------------------------------------------



//  ---------------------------------------------------------------------------------- 
{
  from_mask = bitboard->black_piece[3];
  while(from_mask != 0){
 //    
    from = first_one(from_mask);
//      b = b & (b-1)       
   from_mask = from_mask & (from_mask-1);
//     
//   -  ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_up_right_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = bishop_up_right_masks[from] ^ bishop_up_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_up_right_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//   -  ( )
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_up_left_masks[from];

 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  first_one(blocking_square_mask);
// 3          
   move_mask = bishop_up_left_masks[from] ^ bishop_up_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_up_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   -   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_down_left_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = bishop_down_left_masks[from] ^ bishop_down_left_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_down_left_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//     

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//   -   ( )
// 1   .         
   blocking_square_mask = (bitboard->all_white_piece | bitboard->all_black_piece) & bishop_down_right_masks[from];
 if(blocking_square_mask !=0){ 
   // 2      
   blocking_coordinate =  last_one(blocking_square_mask);
// 3          
   move_mask = bishop_down_right_masks[from] ^ bishop_down_right_masks[blocking_coordinate];
// 4     
   attack_mask = bitboard->all_white_piece & move_masks[blocking_coordinate];
   move_mask = move_mask ^ (attack_mask | ( bitboard->all_black_piece & move_masks[blocking_coordinate]));
 }else{
   move_mask = bishop_down_right_masks[from];
 }//if(blocking_square_mask !=0){ 

// 5     
//      
 if(attack_mask !=0){
    to = first_one(attack_mask);
    attack_mask = attack_mask & (attack_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
 }//if(attack_mask ==0){


//       

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask ^ move_masks[to];
//  64    128  
     n = 16 * (7 - from / 8)+(from % 8);
     n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=4;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;


   }//while (move !=0){
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


 }//while(from_mask != 0){

}
// ---------------------------------------------------------------------------------- 




//   ----------------------------------------------------------------------------------
{//               
//         
  from_mask = bitboard->black_piece[2];
  while(from_mask != 0){
 //    (   )
    from = first_one(from_mask);
//      b = b & (b-1)       
    from_mask = from_mask & (from_mask-1);


//    
   captures_mask = (bitboard->all_white_piece & knigt_moves_masks[from]);

//    ( )
   move_mask = knigt_moves_masks[from] & (~(bitboard->all_white_piece | bitboard->all_black_piece));


//      
  while (captures_mask !=0){
     to = first_one(captures_mask);
     captures_mask = captures_mask & (captures_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=3 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
   }//while (captures !=0){

//-------------------------------------------------------------------------------------

   while (move_mask !=0){
     to = first_one(move_mask);
     move_mask = move_mask & (move_mask-1);
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=3 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
   }//while (move !=0){

 }// while(from_mask != 0){
}
//  ----------------------------------------------------------------------------------

//  ----------------------------------------------------------------------------------
{
  from_mask = bitboard->black_piece[1];
  while(from_mask != 0){
 //    (   )
    from = first_one(from_mask);
 //    
    one_pawn_mask = from_mask & move_masks[from];
//      b = b & (b-1)       
    from_mask = from_mask & (from_mask-1);

// 1         
  move_mask = (one_pawn_mask >> 8) & (~(bitboard->all_white_piece | bitboard->all_black_piece));

// 2     2   
//        2 
  move_mask_d = one_pawn_mask & 71776119061217280;

//       
  move_mask_d = (move_mask_d >>8) & (~(bitboard->all_white_piece | bitboard->all_black_piece));
//    
  move_mask_d = (move_mask_d >> 8) & (~(bitboard->all_white_piece | bitboard->all_black_piece));

//            
  move_mask = (move_mask | move_mask_d) ;


//   
  move_conversion_mask = move_mask & 255;

//   
  move_mask = move_mask & ~255;

// 3   
//  (    ..   1)   (    ..   h1)
 captures_mask = ((one_pawn_mask >> 7) & ~72340172838076673) | ((one_pawn_mask >> 9) & ~9259542123273814144);
 captures_mask = captures_mask &  bitboard->all_white_piece;

//   
captures_conversion_mask = captures_mask & 255;

//  
captures_mask = captures_mask & ~255;

//     
  while (captures_mask !=0){
    to = first_one(captures_mask);
    captures_mask = captures_mask & (captures_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=1 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =1;
     list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
     p=p+1;
   }//while (captures !=0){

//    
  while (move_mask !=0){
    to = first_one(move_mask);
    move_mask = move_mask & (move_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

     list_surplus_moves->name_figure[p]=1 ;
	 list_surplus_moves->initial_position[p] = n;
	 list_surplus_moves->final_position[p] = n_1;
	 list_surplus_moves->description_move[p] =0;
     p=p+1;
   }//while (captures !=0){

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//      
  while (move_conversion_mask !=0){
    to = first_one(move_conversion_mask);
    move_conversion_mask = move_conversion_mask & (move_conversion_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

//   
//    4,   5,   6,   7,
      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =4;
      p=p+1;
      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =5;
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =6;
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =7;
      p=p+1;
   }//while (captures !=0){

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
//        
  while (captures_conversion_mask !=0){
    to = first_one(captures_conversion_mask);
    captures_conversion_mask = captures_conversion_mask & (captures_conversion_mask-1);

//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);

//     
//      8,     9,
//      10,     11,
	  list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =8;
      list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =9;
      list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =10;
      list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1]; 
      p=p+1;

      list_surplus_moves->name_figure[p]=1 ;
	  list_surplus_moves->initial_position[p] = n;
	  list_surplus_moves->final_position[p] = n_1;
	  list_surplus_moves->description_move[p] =11;
      list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1];
       p=p+1;
   }//while (captures !=0){

// 4    
 if(bitboard->taking_passage_yes == 1){
//   
   to = 8*(7-bitboard->taking_passage_y)+(bitboard->taking_passage_x);


   if ( (((from - to) == 9)&&(from % 8!=0)) || (((from - to) == 7)&&(from % 8!=7) ) ){
//  64    128  
    n = 16 * (7 - from / 8)+(from % 8);
    n_1 = 16 * (7 - to / 8)+(to % 8);
	   list_surplus_moves->name_figure[p]=1 ;
	   list_surplus_moves->initial_position[p] = n;
	   list_surplus_moves->final_position[p] = n_1;
       list_surplus_moves->description_move[p] =2;
       list_surplus_moves->name_taking_figure[p]=board_list_816->name_figure_816[n_1-16]; 
       p=p+1;
   }//if ( ( (from - to) == 9) | ((from - to) == 7)){
  }//if(bitboard->taking_passage_yes == 1){
}//while(from_mask != 0){
// ----------------------------------------------------------------------------------
}

}// if (bitboard->colour_move){
list_surplus_moves->end_list[depth]=p;
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_B
    Test_Bitboard.close();
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
}//void Generator_move(){


//	*******************************************************************

//	===================================================================
//
void Piece_print(T_Bitboard * bitboard){
unsigned __int64 test = 8796093022208;

}//void Generator_move(){
//	*******************************************************************


//	===================================================================
//   
void Bitboard_print(T_Bitboard * bitboard){
#if TEST_B
unsigned __int64 z=0;
    Test_Bitboard.open ("_TEST_BITBOARD.txt",ios::app);
 //   Test_Bitboard.open ("_TEST_BITBOARD.txt");

Test_Bitboard << "bitboard->colour_move = "<< bitboard->colour_move <<"\n";

// all_white_piece
//-------------------------------------------------------------------------------------
Test_Bitboard << "\n";
Test_Bitboard << "all_white_piece"<< "\n";
	for (int i=63; i>-1 ; i=i-8){
       for (int j=i-7; j<i+1 ; j++){
         z= bitboard->all_white_piece & move_masks[j];

         if (z == 0){
           Test_Bitboard << "-";
         }else{
           Test_Bitboard << "*";
         }//if (z == 0){ 
	   }//for ( j=i-7; i>j+1 ; j++){
       Test_Bitboard << "\n";
   }//for (int i=63; i>-1 ; i--){
//-------------------------------------------------------------------------------------

// all_black_piece
//-------------------------------------------------------------------------------------
Test_Bitboard << "\n";
Test_Bitboard << "all_black_piece"<< "\n";
	for (int i=63; i>-1 ; i=i-8){
       for (int j=i-7; j<i+1 ; j++){
         z= bitboard->all_black_piece & move_masks[j];

         if (z == 0){
           Test_Bitboard << "-";
         }else{
           Test_Bitboard << "*";
         }//if (z == 0){ 
	   }//for ( j=i-7; i>j+1 ; j++){
       Test_Bitboard << "\n";
   }//for (int i=63; i>-1 ; i--){
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
 Test_Bitboard << "\n";
 Test_Bitboard << "white_piece"<< "\n";
for(int p=1 ; p<7 ; p++){
Test_Bitboard << "\n";
Test_Bitboard << p << "\n";
	for (int i=63; i>-1 ; i=i-8){
       for (int j=i-7; j<i+1 ; j++){
         z=  bitboard->white_piece[p] & move_masks[j];

         if (z == 0){
           Test_Bitboard << "-";
         }else{
           Test_Bitboard << "*";
         }//if (z == 0){ 
	   }//for ( j=i-7; i>j+1 ; j++){
       Test_Bitboard << "\n";
   }//for (int i=63; i>-1 ; i--){
}//for(int i=0 ; i<8 ; i++){
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
 Test_Bitboard << "\n";
 Test_Bitboard << "black_piece"<< "\n";
for(int p=1 ; p<7 ; p++){
Test_Bitboard << "\n";
Test_Bitboard << p << "\n";
	for (int i=63; i>-1 ; i=i-8){
       for (int j=i-7; j<i+1 ; j++){
         z=  bitboard->black_piece[p] & move_masks[j];

         if (z == 0){
           Test_Bitboard << "-";
         }else{
           Test_Bitboard << "*";
         }//if (z == 0){ 
	   }//for ( j=i-7; i>j+1 ; j++){
       Test_Bitboard << "\n";
   }//for (int i=63; i>-1 ; i--){
}//for(int i=0 ; i<8 ; i++){
//-------------------------------------------------------------------------------------



    Test_Bitboard.close();
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
}//void Bitboard_print(T_Bitboard * bitboard){
//	*******************************************************************

//	===================================================================
//    (..  )
static __inline int first_one(unsigned __int64 analyzed_number){ 
   _asm { 
/*
 mov    ()  (). 
      . 
   .     , 
   .    -  
       , 
          
   byte ptr  word ptr. 
     . 
      - 
   ,   .      word ptr:
*/
           mov  eax, dword ptr analyzed_number[0]
/*
 test     
    ,    , 
  SF, ZF  PF.  OF  CF , 
a AF   .     
   .  test   
   .      test  
  ( )   ,   
 -  ( ),     
,         
 .          
    . 

  :

 - 0101
 - 0011
  0001

 SF   1,      
     .
 ZF   1,      
 ,     .
 PF   1,      
         .
*/
           test eax, eax
/*
 ,   
jz  ZF= 1
*/
           jz   grown_up
/*
 bsf        ,  1. 
     (0)  .    
   ,    ZF. 
   ,      
     .     
  ,    0.      bsf 
  ,     ,  
  -       . 
  bsf    16-,   32-  
(  ,       ).
*/
           bsf  eax, eax
/*
 jmp           
.    .      .
*/
           jmp jump_end
           grown_up:    bsf  eax, dword ptr analyzed_number[4]
/*

*/
           add  eax, 20h
           jump_end:
       }//_asm {
}//static __inline int first_one(unsigned __int64 analyzed_number){ 
//	*******************************************************************

//	===================================================================
//    (..  )
static __inline int last_one(unsigned __int64 analyzed_number){ 
  _asm { 
           mov  eax, dword ptr analyzed_number[4]
           test eax, eax
           jz   younger
/*
 bsr        ,  1. 
     (15  31)  . 
      ,    ZF. 
   ,       
    .       , 
   0.      bsr  
 ,     ,   
 -       . 
  bsr    16-,   32- , 
  ,        (  , 
   - ).
*/
           bsr  eax, eax
           add  eax, 20h
           jmp  jump_end
           younger:    bsr  eax, dword ptr analyzed_number[0]
           jump_end:
       }//_asm { 
}//static __inline int last_one(unsigned __int64 analyzed_number){ 
//	*******************************************************************





